function [params_func, segm_params, filepath_params, other_params, ...
            extra_params] = parse_params(varargin)
% divide the parameters from raw input varargin given to rigor_obj_segments
%
% @authors:     Ahmad Humayun
% @contact:     ahumayun@cc.gatech.edu
% @affiliation: Georgia Institute of Technology
% @date:        Fall 2013 - Fall 2014

    segm_params = struct;
    filepath_params = struct;
    other_params = struct;
    chosen_params = false(size(varargin));
    
    % default parameters used, if not specified by the user
    params_func = @params_RIGOR;
    
    % incase user provided number of seeds directly
    if ~isempty(varargin) && isnumeric(varargin{1})
        varargin = ['graph_seed_nums', varargin];
        chosen_params = [0 chosen_params];
    end
    
    if any(strcmpi(varargin, 'params_func'))
        param_pos = find(strcmpi(varargin, 'params_func'), 1, 'first');
        params_func = varargin{param_pos + 1};
        chosen_params([param_pos, param_pos+1]) = true;
    end
    
    if any(strcmpi(varargin, 'segm_params'))
        param_pos = find(strcmpi(varargin, 'segm_params'), 1, 'first');
        segm_params = varargin{param_pos + 1};
        chosen_params([param_pos, param_pos+1]) = true;
    end
    if any(strcmpi(varargin, 'filepath_params'))
        param_pos = find(strcmpi(varargin, 'filepath_params'), 1, 'first');
        filepath_params = varargin{param_pos + 1};
        chosen_params([param_pos, param_pos+1]) = true;
    end
    if any(strcmpi(varargin, 'other_params'))
        param_pos = find(strcmpi(varargin, 'other_params'), 1, 'first');
        other_params = varargin{param_pos + 1};
        chosen_params([param_pos, param_pos+1]) = true;
    end
    
    extra_params = varargin(~chosen_params);
end
