function gen_distro_file()
%GEN_DISTRO_FILE generates a compressed file which can be distributed

    fprintf(2, 'Make sure you ran prep_deploy before this\n');
    
    % find root directory
    code_root_dir = fullfile(fileparts(which(mfilename)), '..');
    
    % check if trained_models exist
    trained_models_dir = fullfile(code_root_dir, 'trained_models');
    assert(exist(trained_models_dir, 'dir') == 7, ...
           'Trained models not copied');
    
    % create deployment directory
    deploy_dir = fullfile(code_root_dir, 'rigor_src');
    mkdir(deploy_dir);
    files = dir(code_root_dir);
    ignored_files = {'.', '..', '.git', 'rigor_src', 'data'};
    for idx = 1:length(files)
        if any(strcmp(files(idx).name, ignored_files))
            continue;
        end
        if files(idx).isdir
            dest_dir = fullfile(code_root_dir, 'rigor_src', files(idx).name);
            mkdir(dest_dir);
            copyfile(fullfile(code_root_dir, files(idx).name), dest_dir);
        else
            copyfile(fullfile(code_root_dir, files(idx).name), ...
                     fullfile(code_root_dir, 'rigor_src'));
        end
    end
    
    % removing all mex files
    system(sprintf('find %s -type f -name *mex*64 | xargs rm', deploy_dir));
    
    % generate zip file
    zip('rigor_src.zip',deploy_dir);
    
    % delete the deployment directory
    rmdir(deploy_dir, 's');
end
